Subject: standard objectives

From: [email-masked] (John D Beutel)
Date: Tue, 22 Oct 91 18:01:57 EDT

There are great ideas on standards flying around.
I'm going to try to summarize them later, but at the moment
see how you like this attempt to list and prioritize
the objectives of the standard:

1.  allow programs to run independent of hardware (i.e., ST, PC, Amiga...)

2.  the interface the programmer needs is already written

3.  allow glove interfaces to be upwardly compatable (i.e., the
    old features always remain so old programs will always work).
    This is pretty easy if people choose to use the standard,
    but the longer there is no standard the more programs can't use it.

4.  allow glove interfaces to be downwardly compatable (i.e.,
    if the interface can't handle some option, it knows how
    to do something almost as good or at least it can
    gracefully inform the user about what it can't handle).
    This is more difficult because it involves substituting
    functions and predicting the future demands of applications
    and future capabilities of interfaces.

There are two main, opposing constraints:

hiding implementation details is good (here's what it does, nevermind how)

reducing functionality is bad (this one can do it, but that one can't)

	(e.g., some people will want the 17 Hz sample rate, but
	that forces an implementation using timers, which some
	hardware may lack.  That extra speed is worth the
	inconsistency of the uncommon hardware that can't do it;
	that hardware's interface will just have to do the next
	best thing, because the absolute lowest common denominator
	is too low.  This is the downward compatability problem again.)

I've seen some great ideas for solutions;  let's talk about them,
put together what we know we've got, and try to nail it down even tho
we can't predict the future.

--
J. David Beutel  11011011  [email-masked]  "I am, therefore I am."